<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="组名称" prop="groupName">
        <el-input
          v-model="queryParams.groupName"
          placeholder="请输入组名称"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="组号" prop="groupCode">
        <el-input
          v-model="queryParams.groupCode"
          placeholder="请输入组号"
          clearable
          @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="Plus"
          @click="handleAdd"
          v-hasPermi="['groupTask:groupTask:add']"
        >新增</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="Edit"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['groupTask:groupTask:edit']"
        >修改</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="Delete"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['groupTask:groupTask:remove']"
        >删除</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="Download"
          @click="handleExport"
          v-hasPermi="['groupTask:groupTask:export']"
        >导出</el-button>
      </el-col>
      <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="groupTaskList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center" />
      <el-table-column label="组名称" align="center" prop="groupName" />
      <el-table-column label="组号" align="center" prop="groupCode" />
      <el-table-column label="启用状态" align="center" prop="status" />
      <el-table-column label="备注" align="center" prop="remark" />
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template #default="scope">
          <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['groupTask:groupTask:edit']">修改</el-button>
          <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['groupTask:groupTask:remove']">删除</el-button>
        </template>
      </el-table-column>
    </el-table>
    
    <pagination
      v-show="total>0"
      :total="total"
      v-model:page="queryParams.pageNum"
      v-model:limit="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改任务动作组对话框 -->
    <el-dialog :title="title" v-model="open" width="60%" append-to-body>
      <el-form ref="groupTaskRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="组名称" prop="groupName">
          <el-input v-model="form.groupName" placeholder="请输入组名称" />
        </el-form-item>
        <el-form-item label="组号" prop="groupCode">
          <el-input v-model="form.groupCode" placeholder="请输入组号" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" type="textarea" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <el-divider content-position="center">动作信息</el-divider> 
      <el-card shadow="always" class="box-card">
        <RroupTaskLine :key="commonKey" ref="groupTaskLine" :groupTask="form"></RroupTaskLine>
      </el-card>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="GroupTask">
import { listGroupTask, getGroupTask, delGroupTask, addGroupTask, updateGroupTask } from "@/api/hnyz/groupTask";
import RroupTaskLine from "./line.vue";

const { proxy } = getCurrentInstance();

const groupTaskList = ref([]);
const groupTaskLine = ref(null);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");
const commonKey = ref(0); // 用于强制刷新子组件

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    groupName: null,
    groupCode: null,
    status: null,
  },
  rules: {
    groupName: [{ required: true, message: "组名不能为空", trigger: "blur" }],
    groupCode: [{ required: true, message: "组号不能为空", trigger: "blur" }],
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询任务动作组列表 */
function getList() {
  loading.value = true;
  listGroupTask(queryParams.value).then(response => {
    groupTaskList.value = response.rows;
    total.value = response.total;
    loading.value = false;
  });
}

// 取消按钮
function cancel() {
  open.value = false;
  reset();
}

// 表单重置
function reset() {
  form.value = {
    groupId: null,
    groupName: null,
    groupCode: null,
    status: null,
    delFlag: null,
    createBy: null,
    updateBy: null,
    createTime: null,
    updateTime: null,
    remark: null
  };
  proxy.resetForm("groupTaskRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.groupId);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
function handleAdd() {
  reset();
  open.value = true;
  title.value = "添加任务动作组";
  form.value.groupId = -1; // 确保新增时groupId为null
  commonKey.value ++;
}

/** 修改按钮操作 */
function handleUpdate(row) {
  reset();
  const _groupId = row.groupId || ids.value
  getGroupTask(_groupId).then(response => {
    form.value = response.data;
    open.value = true;
    title.value = "修改任务动作组";
    commonKey.value ++;
  });
}

/** 提交按钮 */
function submitForm() {
  proxy.$refs["groupTaskRef"].validate(valid => {
    if (valid) {
      const groupTaskLineList = groupTaskLine.value?.getGroupTaskLineList();
      form.value.groupTaskLineList = groupTaskLineList || [];
      if (form.value.groupId != null && form.value.groupId > 0) {
        updateGroupTask(form.value).then(response => {
          proxy.$modal.msgSuccess("修改成功");
          open.value = false;
          getList();
        });
      } else {
        addGroupTask(form.value).then(response => {
          proxy.$modal.msgSuccess("新增成功");
          open.value = false;
          getList();
        });
      }
    }
  });
}

/** 删除按钮操作 */
function handleDelete(row) {
  const _groupIds = row.groupId || ids.value;
  proxy.$modal.confirm('是否确认删除任务动作组编号为"' + _groupIds + '"的数据项？').then(function() {
    return delGroupTask(_groupIds);
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('groupTask/groupTask/export', {
    ...queryParams.value
  }, `groupTask_${new Date().getTime()}.xlsx`)
}

getList();
</script>
